Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/COPYRIGHT
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/COPYRIGHT	(revision 35519)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/COPYRIGHT	(revision 35519)
@@ -0,0 +1,7 @@
+The *.c files in this directory are all part of VirtualBox Open Source
+Edition (OSE), as available from http://www.virtualbox.org. The files
+are free software; you can redistribute them and/or modify them under
+the terms of the GNU General Public License (GPL) as published by the
+Free Software Foundation, in version 2 as it comes in the "COPYING" file
+of the VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvAYUV.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvAYUV.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvAYUV.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uSrcTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvAYUV_void.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvAYUV_void.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvAYUV_void.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCConv()
 {}
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvApplyAYUV.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvApplyAYUV.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvApplyAYUV.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCConvApplyAYUV(vec4 color)
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvBGR.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvBGR.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvBGR.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uSrcTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvBGR_void.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvBGR_void.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvBGR_void.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCConv()
 {}
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvUYVY.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvUYVY.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvUYVY.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uSrcTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvUYVY_void.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvUYVY_void.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvUYVY_void.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCConv()
 {}
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYUY2.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYUY2.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYUY2.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uSrcTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYUY2_void.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYUY2_void.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYUY2_void.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCConv()
 {}
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYV12.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYV12.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYV12.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uSrcTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYV12_void.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYV12_void.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/cconvYV12_void.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCConv()
 {}
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uDstTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst2.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst2.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst2.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uDstTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst_void.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst_void.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/ckeyDst_void.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCKeyDst(void)
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlay.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlay.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlay.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCKeyDst(void);
 void vboxCConv();
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoCKey.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoCKey.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoCKey.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 void vboxCConv();
 void main(void)
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoDiscard.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoDiscard.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoDiscard.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uDstTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoDiscard2.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoDiscard2.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/mainOverlayNoDiscard2.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 #extension GL_ARB_texture_rectangle : enable
 uniform sampler2DRect uDstTex;
Index: /trunk/src/VBox/Frontends/VirtualBox/shaders/splitBGRA.c
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/shaders/splitBGRA.c	(revision 35518)
+++ /trunk/src/VBox/Frontends/VirtualBox/shaders/splitBGRA.c	(revision 35519)
@@ -1,21 +1,2 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * Shader programming for VBoxFBOverlay.
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
 float vboxSplitBGRA(vec4 color, float coord)
 {