Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlExec.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlExec.cpp	(revision 35525)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlExec.cpp	(revision 35526)
@@ -898,10 +898,10 @@
  * @param   uTimeLimitMS
  */
-int VBoxServiceControlExecAllocateThreadData(PVBOXSERVICECTRLTHREAD pThread,
-                                             uint32_t u32ContextID,
-                                             const char *pszCmd, uint32_t uFlags,
-                                             const char *pszArgs, uint32_t uNumArgs,
-                                             const char *pszEnv, uint32_t cbEnv, uint32_t uNumEnvVars,
-                                             const char *pszUser, const char *pszPassword, uint32_t uTimeLimitMS)
+static int VBoxServiceControlExecAllocateThreadData(PVBOXSERVICECTRLTHREAD pThread,
+                                                    uint32_t u32ContextID,
+                                                    const char *pszCmd, uint32_t uFlags,
+                                                    const char *pszArgs, uint32_t uNumArgs,
+                                                    const char *pszEnv, uint32_t cbEnv, uint32_t uNumEnvVars,
+                                                    const char *pszUser, const char *pszPassword, uint32_t uTimeLimitMS)
 {
     AssertPtr(pThread);
@@ -1029,5 +1029,5 @@
 
 /** @todo Maybe we want to have an own IPRT function for that! */
-int VBoxServiceControlExecMakeFullPath(const char *pszPath, char *pszExpanded, size_t cbExpanded)
+static int VBoxServiceControlExecMakeFullPath(const char *pszPath, char *pszExpanded, size_t cbExpanded)
 {
     int rc = VINF_SUCCESS;
@@ -1047,5 +1047,5 @@
 
 
-int VBoxServiceControlExecResolveExecutable(const char *pszFileName, char *pszResolved, size_t cbResolved)
+static int VBoxServiceControlExecResolveExecutable(const char *pszFileName, char *pszResolved, size_t cbResolved)
 {
     int rc = VINF_SUCCESS;
@@ -1097,6 +1097,6 @@
  *                          Needs to be freed with RTGetOptArgvFree.
  */
-int VBoxServiceControlExecPrepareArgv(const char *pszFileName,
-                                      const char * const *papszArgs, char ***ppapszArgv)
+static int VBoxServiceControlExecPrepareArgv(const char *pszFileName,
+                                             const char * const *papszArgs, char ***ppapszArgv)
 {
     AssertPtrReturn(pszFileName, VERR_INVALID_PARAMETER);
@@ -1104,10 +1104,4 @@
     AssertPtrReturn(ppapszArgv, VERR_INVALID_PARAMETER);
 
-    bool fUseToolbox = false;
-    if (RTStrStr(papszArgs[0], "vbox_") == papszArgs[0])
-        fUseToolbox = true;
-
-    /* Skip argv[0] (= file name) if we don't run an internal
-     * VBoxService toolbox command - we already have a resolved one in pszFileName. */
     char *pszArgs;
     int rc = RTGetOptArgvToString(&pszArgs, papszArgs,
@@ -1165,7 +1159,7 @@
  * @param   phProcess
  */
-int VBoxServiceControlExecCreateProcess(const char *pszExec, const char * const *papszArgs, RTENV hEnv, uint32_t fFlags,
-                                        PCRTHANDLE phStdIn, PCRTHANDLE phStdOut, PCRTHANDLE phStdErr, const char *pszAsUser,
-                                        const char *pszPassword, PRTPROCESS phProcess)
+static int VBoxServiceControlExecCreateProcess(const char *pszExec, const char * const *papszArgs, RTENV hEnv, uint32_t fFlags,
+                                               PCRTHANDLE phStdIn, PCRTHANDLE phStdOut, PCRTHANDLE phStdErr, const char *pszAsUser,
+                                               const char *pszPassword, PRTPROCESS phProcess)
 {
     int  rc = VINF_SUCCESS;
@@ -1244,5 +1238,5 @@
  * @param   PVBOXSERVICECTRLTHREAD         Thread data associated with a started process.
  */
-DECLCALLBACK(int) VBoxServiceControlExecProcessWorker(PVBOXSERVICECTRLTHREAD pThread)
+static DECLCALLBACK(int) VBoxServiceControlExecProcessWorker(PVBOXSERVICECTRLTHREAD pThread)
 {
     AssertPtr(pThread);
@@ -1413,5 +1407,5 @@
  * @param   uPID                        PID to search for.
  */
-PVBOXSERVICECTRLTHREAD VBoxServiceControlExecFindProcess(uint32_t uPID)
+static PVBOXSERVICECTRLTHREAD VBoxServiceControlExecFindProcess(uint32_t uPID)
 {
     PVBOXSERVICECTRLTHREAD pNode;