Index: trunk/src/VBox/VMM/VMMR3/PDMDevHlp.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMDevHlp.cpp	(revision 35696)
+++ trunk/src/VBox/VMM/VMMR3/PDMDevHlp.cpp	(revision 35738)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2010 Oracle Corporation
+ * Copyright (C) 2006-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -2812,4 +2812,5 @@
 }
 
+
 /** @interface_method_impl{PDMDEVHLPR3,pfnPciRawRegister} */
 static DECLCALLBACK(int) pdmR3DevHlp_PciRawRegister(PPDMDEVINS pDevIns, PPDMPCIRAWREG pPciRawReg, PCPDMPCIRAWHLPR3 *ppPciRawHlpR3)
@@ -2841,4 +2842,5 @@
     return VINF_SUCCESS;
 }
+
 
 /** @interface_method_impl{PDMDEVHLPR3,pfnDMACRegister} */
@@ -3500,2 +3502,3 @@
 
 /** @} */
+
Index: trunk/src/VBox/VMM/VMMR3/PDMDevMiscHlp.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMDevMiscHlp.cpp	(revision 35696)
+++ trunk/src/VBox/VMM/VMMR3/PDMDevMiscHlp.cpp	(revision 35738)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2010 Oracle Corporation
+ * Copyright (C) 2006-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -651,43 +651,52 @@
 /** @} */
 
-/** @interface_method_impl{PDMPCIRAWHLPR3,pfnGetRCHelpers} */ 
-static DECLCALLBACK(PCPDMPCIRAWHLPRC) pdmR3PciRawHlp_GetRCHelpers(PPDMDEVINS pDevIns) 
-{ 
-    PDMDEV_ASSERT_DEVINS(pDevIns); 
-    VM_ASSERT_EMT(pDevIns->Internal.s.pVMR3); 
-    RTRCPTR pRCHelpers = 0; 
-    int rc = PDMR3LdrGetSymbolRC(pDevIns->Internal.s.pVMR3, NULL, "g_pdmRCPciRawHlp", &pRCHelpers); 
-    AssertReleaseRC(rc); 
-    AssertRelease(pRCHelpers); 
-    LogFlow(("pdmR3PciRawHlp_GetGCHelpers: caller='%s'/%d: returns %RRv\n", 
-             pDevIns->pReg->szName, pDevIns->iInstance, pRCHelpers)); 
-    return pRCHelpers; 
-} 
-
-
-/** @interface_method_impl{PDMPCIRAWHLPR3,pfnGetR0Helpers} */ 
-static DECLCALLBACK(PCPDMPCIRAWHLPR0) pdmR3PciRawHlp_GetR0Helpers(PPDMDEVINS pDevIns) 
-{ 
-    PDMDEV_ASSERT_DEVINS(pDevIns); 
-    VM_ASSERT_EMT(pDevIns->Internal.s.pVMR3); 
-    PCPDMHPETHLPR0 pR0Helpers = 0; 
-    int rc = PDMR3LdrGetSymbolR0(pDevIns->Internal.s.pVMR3, NULL, "g_pdmR0PciRawHlp", &pR0Helpers); 
-    AssertReleaseRC(rc); 
-    AssertRelease(pR0Helpers); 
-    LogFlow(("pdmR3PciRawHlp_GetR0Helpers: caller='%s'/%d: returns %RHv\n", 
-             pDevIns->pReg->szName, pDevIns->iInstance, pR0Helpers)); 
-    return pR0Helpers; 
-} 
-
-/** 
- * Raw PCI Device Helpers. 
- */ 
-const PDMPCIRAWHLPR3 g_pdmR3DevPciRawHlp = 
-{ 
-    PDM_PCIRAWHLPR3_VERSION, 
-    pdmR3PciRawHlp_GetRCHelpers, 
-    pdmR3PciRawHlp_GetR0Helpers, 
-    PDM_PCIRAWHLPR3_VERSION, /* the end */ 
-}; 
+
+/** @name Ring-3 Raw PCI Device Helpers
+ * {@
+ */
+
+/** @interface_method_impl{PDMPCIRAWHLPR3,pfnGetRCHelpers} */
+static DECLCALLBACK(PCPDMPCIRAWHLPRC) pdmR3PciRawHlp_GetRCHelpers(PPDMDEVINS pDevIns)
+{
+    PDMDEV_ASSERT_DEVINS(pDevIns);
+    VM_ASSERT_EMT(pDevIns->Internal.s.pVMR3);
+    RTRCPTR pRCHelpers = NIL_RTRCPTR;
+    int rc = PDMR3LdrGetSymbolRC(pDevIns->Internal.s.pVMR3, NULL, "g_pdmRCPciRawHlp", &pRCHelpers);
+    AssertReleaseRC(rc);
+    AssertRelease(pRCHelpers);
+    LogFlow(("pdmR3PciRawHlp_GetGCHelpers: caller='%s'/%d: returns %RRv\n",
+             pDevIns->pReg->szName, pDevIns->iInstance, pRCHelpers));
+    return pRCHelpers;
+}
+
+
+/** @interface_method_impl{PDMPCIRAWHLPR3,pfnGetR0Helpers} */
+static DECLCALLBACK(PCPDMPCIRAWHLPR0) pdmR3PciRawHlp_GetR0Helpers(PPDMDEVINS pDevIns)
+{
+    PDMDEV_ASSERT_DEVINS(pDevIns);
+    VM_ASSERT_EMT(pDevIns->Internal.s.pVMR3);
+    PCPDMHPETHLPR0 pR0Helpers = NIL_RTR0PTR;
+    int rc = PDMR3LdrGetSymbolR0(pDevIns->Internal.s.pVMR3, NULL, "g_pdmR0PciRawHlp", &pR0Helpers);
+    AssertReleaseRC(rc);
+    AssertRelease(pR0Helpers);
+    LogFlow(("pdmR3PciRawHlp_GetR0Helpers: caller='%s'/%d: returns %RHv\n",
+             pDevIns->pReg->szName, pDevIns->iInstance, pR0Helpers));
+    return pR0Helpers;
+}
+
+
+/**
+ * Raw PCI Device Helpers.
+ */
+const PDMPCIRAWHLPR3 g_pdmR3DevPciRawHlp =
+{
+    PDM_PCIRAWHLPR3_VERSION,
+    pdmR3PciRawHlp_GetRCHelpers,
+    pdmR3PciRawHlp_GetR0Helpers,
+    PDM_PCIRAWHLPR3_VERSION, /* the end */
+};
+
+/** @} */
+
 
 /* none yet */