Index: trunk/src/VBox/Additions/x11/vboxvideo/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/x11/vboxvideo/Makefile.kmk	(revision 35778)
+++ trunk/src/VBox/Additions/x11/vboxvideo/Makefile.kmk	(revision 35779)
@@ -306,5 +306,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv) $(VBOXVIDEO_SRC_PATH)/undefined_13 --static
+	    $(INSTARGET_vboxvideo_drv) $(VBOXVIDEO_SRC_PATH)/undefined --static
 	$(QUIET)$(APPEND) -t "$@" "done"
      endif
@@ -315,5 +315,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_70) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_70) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -323,5 +323,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_71) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_71) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -331,5 +331,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_13) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_13) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -339,5 +339,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_14) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_14) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -347,5 +347,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_15) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_15) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -355,5 +355,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_16) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_16) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -363,5 +363,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_17) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_17) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -371,5 +371,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_18) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_18) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
@@ -379,5 +379,5 @@
 	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
 	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_TARGET)  \
-	    $(INSTARGET_vboxvideo_drv_19) $(VBOXVIDEO_SRC_PATH)/undefined_13
+	    $(INSTARGET_vboxvideo_drv_19) $(VBOXVIDEO_SRC_PATH)/undefined
 	$(QUIET)$(APPEND) -t "$@" "done"
 
Index: trunk/src/VBox/Additions/x11/vboxvideo/undefined
===================================================================
--- trunk/src/VBox/Additions/x11/vboxvideo/undefined	(revision 35779)
+++ trunk/src/VBox/Additions/x11/vboxvideo/undefined	(revision 35779)
@@ -0,0 +1,199 @@
+DRICloseScreen
+DRICreateInfoRec
+DRICreatePCIBusID
+DRIDestroyInfoRec
+DRIFinishScreenInit
+DRILock
+DRIQueryVersion
+DRIScreenInit
+DRIUnlock
+ErrorF
+FatalError
+GlxSetVisualConfigs
+LoaderRefSymLists
+MakeAtom
+PixmapWidthPaddingInfo
+RRChangeOutputProperty
+ShadowFBInit2
+VBEExtendedInit
+VBEGetVBEMode
+VBESaveRestore
+VBESetDisplayStart
+VBESetGetPaletteData
+VBESetVBEMode
+XNFcalloc
+XNFstrdup
+_Jv_RegisterClasses
+___errno
+__cxa_finalize
+__deregister_frame_info_bases
+__divdi3
+__errno_location
+__fxstat64
+__gmon_start__
+__iob
+__isoc99_sscanf
+__moddi3
+__register_frame_info_bases
+__stack_chk_fail
+__udivdi3
+__umoddi3
+__xstat64
+calloc
+chdir
+chmod
+chown
+close
+drmFreeVersion
+drmGetVersion
+fbPictureInit
+fbScreenInit
+fchmod
+fcntl
+fflush
+flock
+fprintf
+fputs
+free
+fstat
+fsync
+ftruncate
+ftruncate64
+futimes
+getcwd
+getenv
+geteuid
+getpwuid_r
+iconv
+iconv_close
+iconv_open
+ioctl
+lchown
+lseek
+lseek64
+malloc
+memalign
+memchr
+memcmp
+memcpy
+memmove
+memset
+miClearVisualTypes
+miCreateDefColormap
+miDCInitialize
+miInitializeBackingStore
+miSetPixmapDepths
+miSetVisualTypes
+mmap64
+mprotect
+munmap
+nl_langinfo
+open
+open64
+pciFindFirst
+pciReadLong
+pciTag
+pci_device_map_range
+pci_device_next
+pci_device_probe
+pci_device_unmap_range
+pci_id_match_iterator_create
+pci_iterator_destroy
+posix_memalign
+pthread_sigmask
+putenv
+read
+realloc
+realpath
+rename
+resVgaShared
+screenInfo
+serverGeneration
+setenv
+sigdelset
+sigfillset
+sprintf
+snprintf
+sscanf
+sscanf
+stat
+stderr
+strchr
+strcmp
+strcpy
+strncpy
+strlen
+strncmp
+strpbrk
+strstr
+symlink
+tolower
+unlink
+unsetenv
+utimes
+vgaHWFreeHWRec
+vgaHWGetHWRec
+vgaHWGetIndex
+vgaHWHandleColormaps
+vgaHWMapMem
+vgaHWRestoreFonts
+vgaHWSaveFonts
+vgaHWUnmapMem
+write
+xf86AddDriver
+xf86CVTMode
+xf86CheckModeForMonitor
+xf86CollectOptions
+xf86ConfigPciEntity
+xf86CreateCursorInfoRec
+xf86CrtcConfigInit
+xf86CrtcConfigPrivateIndex
+xf86CrtcCreate
+xf86CrtcScreenInit
+xf86CrtcSetSizeRange
+xf86DPMSInit
+xf86DPMSSet
+xf86DestroyCursorInfoRec
+xf86DiDGAInit
+xf86DrvMsg
+xf86GetEntityInfo
+xf86GetPciInfoForEntity
+xf86GetPciVideoInfo
+xf86GetPointerScreenFuncs
+xf86HandleColormaps
+xf86InitCursor
+xf86InitialConfiguration
+xf86InterpretEDID
+xf86LoadSubModule
+xf86LoaderCheckSymbol
+xf86LoaderReqSymLists
+xf86MapDomainMemory
+xf86MapPciMem
+xf86MatchDevice
+xf86MatchPciInstances
+xf86ModesAdd
+xf86Msg
+xf86OutputCreate
+xf86OutputUseScreenMonitor
+xf86PrintChipsets
+xf86PrintDepthBpp
+xf86PrintModes
+xf86ProcessOptions
+xf86SaveScreen
+xf86Screens
+xf86SetBackingStore
+xf86SetBlackWhitePixels
+xf86SetDefaultVisual
+xf86SetDepthBpp
+xf86SetDesiredModes
+xf86SetDpi
+xf86OutputSetEDID
+xf86SetGamma
+xf86SetModeDefaultName
+xf86SetSingleMode
+xf86SetWeight
+xf86ShowUnusedOptions
+xf86SlowBcopy
+xf86UnMapVidMem
+xf86sprintf
+xf86snprintf
Index: trunk/src/VBox/Additions/x11/vboxvideo/undefined_13
===================================================================
--- trunk/src/VBox/Additions/x11/vboxvideo/undefined_13	(revision 35778)
+++ 	(revision )
@@ -1,199 +1,0 @@
-DRICloseScreen
-DRICreateInfoRec
-DRICreatePCIBusID
-DRIDestroyInfoRec
-DRIFinishScreenInit
-DRILock
-DRIQueryVersion
-DRIScreenInit
-DRIUnlock
-ErrorF
-FatalError
-GlxSetVisualConfigs
-LoaderRefSymLists
-MakeAtom
-PixmapWidthPaddingInfo
-RRChangeOutputProperty
-ShadowFBInit2
-VBEExtendedInit
-VBEGetVBEMode
-VBESaveRestore
-VBESetDisplayStart
-VBESetGetPaletteData
-VBESetVBEMode
-XNFcalloc
-XNFstrdup
-_Jv_RegisterClasses
-___errno
-__cxa_finalize
-__deregister_frame_info_bases
-__divdi3
-__errno_location
-__fxstat64
-__gmon_start__
-__iob
-__isoc99_sscanf
-__moddi3
-__register_frame_info_bases
-__stack_chk_fail
-__udivdi3
-__umoddi3
-__xstat64
-calloc
-chdir
-chmod
-chown
-close
-drmFreeVersion
-drmGetVersion
-fbPictureInit
-fbScreenInit
-fchmod
-fcntl
-fflush
-flock
-fprintf
-fputs
-free
-fstat
-fsync
-ftruncate
-ftruncate64
-futimes
-getcwd
-getenv
-geteuid
-getpwuid_r
-iconv
-iconv_close
-iconv_open
-ioctl
-lchown
-lseek
-lseek64
-malloc
-memalign
-memchr
-memcmp
-memcpy
-memmove
-memset
-miClearVisualTypes
-miCreateDefColormap
-miDCInitialize
-miInitializeBackingStore
-miSetPixmapDepths
-miSetVisualTypes
-mmap64
-mprotect
-munmap
-nl_langinfo
-open
-open64
-pciFindFirst
-pciReadLong
-pciTag
-pci_device_map_range
-pci_device_next
-pci_device_probe
-pci_device_unmap_range
-pci_id_match_iterator_create
-pci_iterator_destroy
-posix_memalign
-pthread_sigmask
-putenv
-read
-realloc
-realpath
-rename
-resVgaShared
-screenInfo
-serverGeneration
-setenv
-sigdelset
-sigfillset
-sprintf
-snprintf
-sscanf
-sscanf
-stat
-stderr
-strchr
-strcmp
-strcpy
-strncpy
-strlen
-strncmp
-strpbrk
-strstr
-symlink
-tolower
-unlink
-unsetenv
-utimes
-vgaHWFreeHWRec
-vgaHWGetHWRec
-vgaHWGetIndex
-vgaHWHandleColormaps
-vgaHWMapMem
-vgaHWRestoreFonts
-vgaHWSaveFonts
-vgaHWUnmapMem
-write
-xf86AddDriver
-xf86CVTMode
-xf86CheckModeForMonitor
-xf86CollectOptions
-xf86ConfigPciEntity
-xf86CreateCursorInfoRec
-xf86CrtcConfigInit
-xf86CrtcConfigPrivateIndex
-xf86CrtcCreate
-xf86CrtcScreenInit
-xf86CrtcSetSizeRange
-xf86DPMSInit
-xf86DPMSSet
-xf86DestroyCursorInfoRec
-xf86DiDGAInit
-xf86DrvMsg
-xf86GetEntityInfo
-xf86GetPciInfoForEntity
-xf86GetPciVideoInfo
-xf86GetPointerScreenFuncs
-xf86HandleColormaps
-xf86InitCursor
-xf86InitialConfiguration
-xf86InterpretEDID
-xf86LoadSubModule
-xf86LoaderCheckSymbol
-xf86LoaderReqSymLists
-xf86MapDomainMemory
-xf86MapPciMem
-xf86MatchDevice
-xf86MatchPciInstances
-xf86ModesAdd
-xf86Msg
-xf86OutputCreate
-xf86OutputUseScreenMonitor
-xf86PrintChipsets
-xf86PrintDepthBpp
-xf86PrintModes
-xf86ProcessOptions
-xf86SaveScreen
-xf86Screens
-xf86SetBackingStore
-xf86SetBlackWhitePixels
-xf86SetDefaultVisual
-xf86SetDepthBpp
-xf86SetDesiredModes
-xf86SetDpi
-xf86OutputSetEDID
-xf86SetGamma
-xf86SetModeDefaultName
-xf86SetSingleMode
-xf86SetWeight
-xf86ShowUnusedOptions
-xf86SlowBcopy
-xf86UnMapVidMem
-xf86sprintf
-xf86snprintf
Index: trunk/src/VBox/Additions/x11/vboxvideo/undefined_68
===================================================================
--- trunk/src/VBox/Additions/x11/vboxvideo/undefined_68	(revision 35778)
+++ 	(revision )
@@ -1,108 +1,0 @@
-DGAInit
-ErrorF
-FatalError
-LoaderRefSymLists
-PixmapWidthPaddingInfo
-SetTimeSinceLastInputEvent
-ShadowFBInit2
-VBEExtendedInit
-VBEGetVBEMode
-VBEInit
-VBESaveRestore
-VBESetDisplayStart
-VBESetGetPaletteData
-VBESetVBEMode
-VErrorF
-XNFalloc
-XNFcalloc
-XNFrealloc
-XNFstrdup
-Xalloc
-Xcalloc
-Xfree
-Xrealloc
-fbPictureInit
-fbScreenInit
-flock
-miClearVisualTypes
-miCreateDefColormap
-miDCInitialize
-miInitializeBackingStore
-miSetPixmapDepths
-miSetVisualTypes
-pciFindFirst
-pciReadLong
-pciTag
-pthread_sigmask
-resVgaShared
-serverGeneration
-sigdelset
-sigfillset
-vgaHWDPMSSet
-vgaHWFreeHWRec
-vgaHWGetHWRec
-vgaHWGetIndex
-vgaHWHandleColormaps
-vgaHWMapMem
-vgaHWRestoreFonts
-vgaHWSaveFonts
-vgaHWSaveScreen
-vgaHWUnmapMem
-xf86AddDriver
-xf86CollectOptions
-xf86ConfigPciEntity
-xf86CreateCursorInfoRec
-xf86DPMSInit
-xf86DestroyCursorInfoRec
-xf86DrvMsg
-xf86GetEntityInfo
-xf86GetPciInfoForEntity
-xf86GetPciVideoInfo
-xf86GetPointerScreenFuncs
-xf86HandleColormaps
-xf86InitCursor
-xf86IsUnblank
-xf86LoadSubModule
-xf86LoaderReqSymLists
-xf86MapPciMem
-xf86MapVidMem
-xf86MatchDevice
-xf86MatchPciInstances
-xf86Msg
-xf86PrintChipsets
-xf86PrintDepthBpp
-xf86PrintModes
-xf86ProcessOptions
-xf86PruneDriverModes
-xf86Screens
-xf86SetBackingStore
-xf86SetBlackWhitePixels
-xf86SetDefaultVisual
-xf86SetDepthBpp
-xf86SetDpi
-xf86SetGamma
-xf86SetWeight
-xf86ShowUnusedOptions
-xf86SlowBcopy
-xf86UnMapVidMem
-xf86ValidateModes
-xf86calloc
-xf86close
-xf86errno
-xf86free
-xf86ioctl
-xf86isspace
-xf86malloc
-xf86memchr
-xf86memcpy
-xf86memset
-xf86open
-xf86sprintf
-xf86sscanf
-xf86strcmp
-xf86strcpy
-xf86strdup
-xf86strerror
-xf86strlen
-xf86strtoul
-xf86vsnprintf
Index: trunk/src/VBox/Additions/x11/vboxvideo/undefined_70
===================================================================
--- trunk/src/VBox/Additions/x11/vboxvideo/undefined_70	(revision 35778)
+++ 	(revision )
@@ -1,197 +1,0 @@
-DGAInit
-DRICloseScreen
-DRICreateInfoRec
-DRICreateInfoRec sprintf
-DRICreatePCIBusID
-DRIDestroyInfoRec
-DRIFinishScreenInit
-DRILock
-DRIQueryVersion
-DRIScreenInit
-DRIUnlock
-ErrorF
-FatalError
-GlxSetVisualConfigs
-LoaderRefSymLists
-PixmapWidthPaddingInfo
-SetTimeSinceLastInputEvent
-ShadowFBInit2
-VBEExtendedInit
-VBEGetVBEMode
-VBESaveRestore
-VBESetDisplayStart
-VBESetGetPaletteData
-VBESetVBEMode
-XNFalloc
-XNFcalloc
-XNFprintf
-XNFrealloc
-XNFstrdup
-Xalloc
-Xcalloc
-Xfree
-Xrealloc
-_GLOBAL_OFFSET_TABLE_
-_Jv_RegisterClasses
-___errno
-__cxa_finalize
-__deregister_frame_info_bases
-__divdi3
-__errno_location
-__fxstat64
-__gmon_start__
-__iob
-__isoc99_sscanf
-__moddi3
-__register_frame_info_bases
-__stack_chk_fail
-__udivdi3
-__umoddi3
-__xstat64
-calloc
-chdir
-chmod
-chown
-close
-drmFreeVersion
-drmGetVersion
-fbPictureInit
-fbScreenInit
-fchmod
-fcntl
-fflush
-flock
-fprintf
-fputs
-free
-fstat
-fsync
-ftruncate
-ftruncate64
-futimes
-getcwd
-getenv
-geteuid
-getpwuid_r
-iconv
-iconv_close
-iconv_open
-ioctl
-lchown
-lseek
-lseek64
-malloc
-memalign
-memchr
-memcmp
-memcpy
-memmove
-memset
-miClearVisualTypes
-miCreateDefColormap
-miDCInitialize
-miInitializeBackingStore
-miSetPixmapDepths
-miSetVisualTypes
-mmap64
-mprotect
-munmap
-nl_langinfo
-open
-open64
-pciFindFirst
-pciReadLong
-pciTag
-pci_device_map_range
-pci_device_next
-pci_device_probe
-pci_device_unmap_range
-pci_id_match_iterator_create
-pci_iterator_destroy
-posix_memalign
-pthread_sigmask
-putenv
-read
-realloc
-realpath
-rename
-resVgaShared
-screenInfo
-serverGeneration
-setenv
-sigdelset
-sigfillset
-sprintf
-stat
-stderr
-strchr
-strcmp
-strcpy
-strlen
-strncmp
-strpbrk
-strstr
-symlink
-tolower
-unlink
-unsetenv
-utimes
-vgaHWDPMSSet
-vgaHWFreeHWRec
-vgaHWGetHWRec
-vgaHWGetIndex
-vgaHWHandleColormaps
-vgaHWMapMem
-vgaHWRestoreFonts
-vgaHWSaveFonts
-vgaHWSaveScreen
-vgaHWUnmapMem
-write
-xf86AddDriver
-xf86CollectOptions
-xf86ConfigPciEntity
-xf86CreateCursorInfoRec
-xf86DPMSInit
-xf86DestroyCursorInfoRec
-xf86DrvMsg
-xf86GetEntityInfo
-xf86GetPciInfoForEntity
-xf86GetPciVideoInfo
-xf86GetPointerScreenFuncs
-xf86HandleColormaps
-xf86InitCursor
-xf86IsUnblank
-xf86LoadSubModule
-xf86LoaderCheckSymbol
-xf86LoaderReqSymLists
-xf86MapDomainMemory
-xf86MapPciMem
-xf86MatchDevice
-xf86MatchPciInstances
-xf86Msg
-xf86PrintChipsets
-xf86PrintDepthBpp
-xf86PrintModes
-xf86ProcessOptions
-xf86PruneDriverModes
-xf86Screens
-xf86SetBackingStore
-xf86SetBlackWhitePixels
-xf86SetDefaultVisual
-xf86SetDepthBpp
-xf86SetDpi
-xf86SetGamma
-xf86SetWeight
-xf86ShowUnusedOptions
-xf86SlowBcopy
-xf86UnMapVidMem
-xf86ValidateModes
-xf86errno
-xf86isspace
-xf86memcpy
-xf86memset
-xf86sprintf
-xf86sscanf
-xf86strdup
-xf86strtoul
-xf86vsnprintf